import type { ClientEvents, GatewayDispatchEvents } from 'discord.js';
import type { GClient } from '../GClient';
export interface ListenerOptions<WS extends boolean, Event extends WS extends true ? GatewayDispatchEvents : keyof ClientEvents> {
    event: Event | string;
    name: string;
    once?: boolean;
    ws?: WS;
    fileName?: string;
    run?: (...args: Event extends keyof ClientEvents ? ClientEvents[Event] : Array<any>) => any;
}
export declare class Listener<WS extends boolean = boolean, Event extends WS extends true ? GatewayDispatchEvents : keyof ClientEvents = WS extends true ? GatewayDispatchEvents : keyof ClientEvents> {
    client: GClient;
    event: Event | string;
    name: string;
    once?: boolean;
    ws?: WS;
    fileName?: string;
    run: (...args: Array<any>) => any;
    owner?: string;
    reloading: boolean;
    options: ListenerOptions<WS, Event>;
    constructor(options: ListenerOptions<WS, Event>);
    initialize(client: GClient): void;
    unregister(): Listener | void;
    _run(...args: Array<any>): Promise<void>;
    reload(): Promise<Listener>;
}
//# sourceMappingURL=Listener.d.ts.map